%global _dwz_low_mem_die_limit 0
#debuginfo not supported with Go
#%%global debug_package %%{nil}
# modifying the Go binaries breaks the DWARF debugging
#%%global __os_install_post %%{_rpmconfigdir}/brp-compress

%if ! 0%{?gobuild:1}
%define gobuild(o:) go build -buildmode pie -gccgoflags '-static-libgcc -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -specs=/usr/lib/rpm/redhat/redhat-hardened-ld -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1' -tags=rpm_crashtraceback -ldflags "-compressdwarf=false ${LDFLAGS:-} -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n') -extldflags '-Wl,-z,relro,-z,now -specs=/usr/lib/rpm/redhat/redhat-hardened-ld'" -a -v -x %{?**};
%endif

%global gopath      %{_datadir}/gocode
%global import_path github.com/fusor/cpma

Name:           cpma
Version:        1.0.1
Release:        10%{?dist}
Summary:        CPMA Client
License:        ASL 2.0
URL:            https://%{import_path}
Source0: https://github.com/fusor/cpma/archive/release-1.0.tar.gz#/%{name}-%{version}.tar.gz

# If go_arches not defined fall through to implicit golang archs
%if 0%{?go_arches:1}
ExclusiveArch:  %{go_arches}
%else
ExclusiveArch:  x86_64 aarch64 ppc64le s390x
%endif

BuildRequires: golang

Provides:       %{name} = %{version}-%{release}

%description
%{summary}

%package redistributable
Summary:        CPMA Client Binaries for Linux, Mac, and Windows
Provides:       %{name}-redistributable = %{version}-%{release}

%description redistributable
%{summary}

%prep
%setup -q

%build
mkdir -p "$(dirname __gopath/src/%{import_path})"
ln -s "$(pwd)" "__gopath/src/%{import_path}"
export GOPATH=$(pwd)/__gopath:%{gopath}
cd "__gopath/src/%{import_path}"

%ifarch %{ix86}
GOOS=linux
GOARCH=386
%endif
%ifarch ppc64le
GOOS=linux
GOARCH=ppc64le
%endif
%ifarch %{arm} aarch64
GOOS=linux
GOARCH=arm64
%endif
%ifarch s390x
GOOS=linux
GOARCH=s390x
%endif
pushd pkg/transform/reportoutput/ && go generate && popd
CGO_ENABLED=0 GOOS=linux GOARCH=amd64 %gobuild -o %{name}
CGO_ENABLED=0 GOOS=linux GOARCH=amd64 %gobuild -o %{name}-redis

%ifarch x86_64
CGO_ENABLED=0 GOOS=darwin GOARCH=amd64 GO_BUILD_FLAGS="-tags 'include_gcs include_oss containers_image_openpgp'" go build -o _output/darwin_amd64/%{name}

GOOS=windows GOARCH=amd64 go build -o _output/windows_amd64/%{name}.exe
%endif

%install
install -d %{buildroot}%{_bindir}

# Install for the local platform
install -p -m 755 ./%{name} %{buildroot}%{_bindir}/%{name}

%ifarch x86_64
# Install client executable for windows and mac
install -d %{buildroot}%{_datadir}/%{name}/{linux,macosx,windows}
install -p -m 755 ./%{name}-redis %{buildroot}%{_datadir}/%{name}/linux/%{name}
install -p -m 755 ./_output/darwin_amd64/%{name} %{buildroot}/%{_datadir}/%{name}/macosx/%{name}
install -p -m 755 ./_output/windows_amd64/%{name}.exe %{buildroot}/%{_datadir}/%{name}/windows/%{name}.exe
%endif

%files
%{_bindir}/%{name}

%ifarch x86_64
%files redistributable
%dir %{_datadir}/%{name}/linux/
%dir %{_datadir}/%{name}/macosx/
%dir %{_datadir}/%{name}/windows/
%{_datadir}/%{name}/linux/%{name}
%{_datadir}/%{name}/macosx/%{name}
%{_datadir}/%{name}/windows/%{name}.exe
%endif

%changelog
* Tue Oct 29 2019 Jason Montleon jmontleo@redhat.com 1.0.1-10
- Add gcc specs

* Tue Oct 29 2019 Jason Montleon jmontleo@redhat.com 1.0.1-9
- Add ld spec

* Tue Oct 29 2019 Jason Montleon jmontleo@redhat.com 1.0.1-8
- Add removed ldflags back

* Tue Oct 29 2019 Jason Montleon jmontleo@redhat.com 1.0.1-7
- Enable debuginfo

* Tue Oct 29 2019 Jason Montleon jmontleo@redhat.com 1.0.1-6
- Manually strip-debug too

* Tue Oct 29 2019 Jason Montleon jmontleo@redhat.com 1.0.1-5
- Manually strip binary instead of relying on ld/brp-strip

* Tue Oct 29 2019 Jason Montleon jmontleo@redhat.com 1.0.1-4
- Strip binary

* Tue Oct 29 2019 Jason Montleon jmontleo@redhat.com 1.0.1-3
- Strip binary

* Tue Oct 29 2019 Jason Montleon jmontleo@redhat.com 1.0.1-2
- Build Static

* Mon Oct 21 2019 Jason Montleon jmontleo@redhat.com 1.0.1-1
- Update with latest release-1.0 fixes e3129a3

* Wed Oct 16 2019 Jason Montleon jmontleo@redhat.com 1.0.0-2
- Use gobuild macro to fix execshield issues

* Tue Oct 1 2019 Jason Montleon jmontleo@redhat.com 1.0.0-1
- Initial Build
